/*
 $Revision: 1.8 $
 $Date: 2010/02/08 17:49:53 $
 $Author: apollan $
 $Name:  $
 $Id: ckm.h,v 1.8 2010/02/08 17:49:53 apollan Exp $
 */

#if !defined(__CKM_H)
#define __CKM_H

/* ========================== PROTOTYPES ============================= */

typedef enum
  {
  KENTROPIES,
  KDISTRIBUTIONS,
  KHISTOGRAMS,
  KMEDOIDS,
  KMODES,
  DKENTROPIES,
  HKENTROPIES,
  STKMEDOIDS,
  DTKMEDOIDS
  } CLUSTERINGMETHOD;


CATDISTANCETYPE GetDistanceMetric    (CLUSTERINGMETHOD method);
CATCENTROIDTYPE GetRepresentativeType(CLUSTERINGMETHOD method);

int PerformKEntropies   (PARTITIONING *pP,
                         CATCODEBOOK *pCCB,
                         TRAININGSET *pTS,
                         int kmIter,
                         int quietLevel,
                         CATINITMETHOD initMethod,
                         CLUSTERINGMETHOD method);

int PerformKMedoidsDistanceTable(PARTITIONING *pP,
                                 CATCODEBOOK *pCCB,
                                 TRAININGSET *pTS,
                                 int kmIter,
                                 int quietLevel,
                                 CATINITMETHOD initMethod);

int PerformKHistograms  (PARTITIONING *pP,
                         CATCODEBOOK *pCCB,
                         TRAININGSET *pTS,
                         int kmIter,
                         int quietLevel,
                         CATINITMETHOD initMethod,
                         CLUSTERINGMETHOD method);

typedef struct {
  CATCODEBOOK* pCodebook;
  CATCODEBOOK* pDecreaseCost;
  CATCODEBOOK* pIncreaseCost;
  } KEDATA;


#endif /* __CKM_H */
