/*
 $Revision: 1.8 $
 $Date: 2009/12/01 11:59:48 $
 $Author: apollan $
 $Name:  $
 $Id: rock.h,v 1.8 2009/12/01 11:59:48 apollan Exp $
 */

#if !defined(__ROCK_H)
#define __ROCK_H

/* ========================== PROTOTYPES ============================= */

typedef struct
  {
  int Links;
  double Cost;
  int Index;
  int Cluster1;
  int Cluster2;
  } CLUSTERPAIR;

typedef struct
  {
  double Theta;
  int x;
  CLUSTERPAIR* Pairs;
  HEAP GlobalHeap;
  UTM utm;
  } ROCKDATA;


#define     EQUAL                                        1
#define     ERROR_IMPOSSIBLE_NUMBER_OF_CLUSTERS          1

/* ========================== PROTOTYPES ============================= */

int ROCKInit(PARTITIONING* pP,
             TRAININGSET* pTS,
             ROCKDATA* data,
             double theta,
             int quietLevel);

int ROCKIteration(PARTITIONING* pP, TRAININGSET* pTS, ROCKDATA* data,
    int quietLevel);

int ROCKFree(ROCKDATA* data, int quietLevel);

int PerformROCK(PARTITIONING* pP,
                TRAININGSET* pTS,
                int k,
                double theta,
                int quietLevel,
                int* outlierCluster);

#endif /* __ROCK_H */
