#!/bin/awk -f

BEGIN {
	sum = 0.0
	low = 0
	high = 0
}

{
	if (NR == 1) {
		low = $1
		high = $1
	}

	if ($1 < low) {
		low = $1
	}

	if ($1 > high) {
		high = $1
	}

	sum += $1
	store[NR] = $1
}

END {
	avg = sum / NR;
	
	#print "Average:   "  avg;

	sum = 0
	for (i = 1; i <= NR; i++)
		sum += (store[i] - avg) * (store[i] - avg);

	var = sum / NR;
	dev = sqrt(var);


	print low " " avg " " high " " var " " dev ";";

	#print "Variance:  "  var;
	#print "Deviation: "  dev;

	#print "Highest:   "  high;
	#print "Lowest:    "  low;
}
